/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: copyenv.c,v 1.1 2003/11/16 04:47:18 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "getCGIparm.h"

int
getCGIparmenv( u_int32_t flags
    , const u_char ** envp
    , const u_char * const tofind
    , const u_char * const query_delimit
    , const u_char * const null_sign
    ) {
    u_char *unescaped, *p, *q, *f1, *f2;
    int i, agrmax, k, ex = EX_OK;
    const u_char *empty = "";

    if  (flags & gCGI_VERB)
        fprintf( stderr
               , "EN flags=%06X, tofind=%s~, query_delimit=%s~, null_sign=%s~\n"
               , flags
               , tofind ? tofind : empty
               , query_delimit
               , null_sign
               );
    for (i = 0, agrmax = 0; envp && envp[i]; i++) {
        if  (flags & gCGI_VERM) fprintf(stderr, "%s~\n", envp[i]);
        k = strlen(envp[i]);
        if  (k > agrmax) agrmax = k;
    }
    unescaped = malloc(agrmax + 1);
    if  (!unescaped)                                                               return(EX_TEMPFAIL);
    f1 = f2 = NULL;

    for (i = 0; !ex && envp && envp[i]; i++) {
        q = unescaped;
        strlcpy(unescaped, envp[i], agrmax);
        p = strsep(&q, "=");
        if  (flags & gCGI_VERB) fprintf(stderr, "p=%s~ q=%s~\n", p, q);
        if  (!(ex = getCGIparmpass2(flags, tofind, q)) && ~flags & gCGI_OTST) {
            f1 = p;
            if  (p && (ex = getCGIparmpass3(flags, "copy", &p))) break;
            f2 = q;
            if  ((ex = getCGIparmpass3(flags, "copy", &q))) break;
            if  (flags & gCGI_RNUM) printf("%d%s", i, query_delimit);
            if  (!p) printf("%s%s", null_sign, query_delimit);
              else printf("%s%s", p, query_delimit);
            printf("%s\n", q);
            if  (p && p != f1) {
                free(p);
                p = NULL;
            }
            if  (q != f2) {
                free(q);
                q = NULL;
    }   }   }
    if  (p && p != f1) free(p);
    if  (q && q != f2) free(q);
    if  (!ex) printf("\\.\n");
    free(unescaped);
    if  (flags & gCGI_VERB) fprintf(stderr, "EN ex=%d\n", ex);
    return(ex);
}
